/*
  State change detection (edge detection) 
 Szélsőérték érzékelés: Ez a példa azt mutatja meg, hogyan lehet érzékelni, amikor a gomb állapota megváltozik.
 
 created  27 Sep 2005
 modified 30 Aug 2011 by Tom Igoe
 - */

const int  buttonPin = 2;    
const int ledPin = 13;       

// létrehozzuk a megnyomások darabszámát tároló változót:
int buttonPushCounter = 0;   
int buttonState = 0;    // gomb aktuális állapotát tárolja
int lastButtonState = 0;  // gomb előző állapotát tárolja

void setup() {
  // nyomógomb pinjét bemenetként inicializáljuk:
  pinMode(buttonPin, INPUT);
  // LED pinjét pedig kimenetként:
  pinMode(ledPin, OUTPUT);
  // inicializáljuk a soros portot (9600 bit/sec):
  Serial.begin(9600);
}


void loop() {
  // kiolvassuk a nyomógomb bemeneti pinjét:
  buttonState = digitalRead(buttonPin);

  // összehasonlítja a nyomógomb aktuális 
  // állapotát az előzővel:
  if (buttonState != lastButtonState) {

    // ha az állapot változott, megnöveli a számláló értékét:
    if (buttonState == HIGH) {
      // ha az aktuális állapot HIGH, akkor 
      // a gomb meg lett nyomva
      buttonPushCounter++;
      Serial.println("on");  

      // ekkor a serial motor kiírja az on szót, 
      // és a megnyomások számát is:
      Serial.print("number of button pushes:  ");
      Serial.println(buttonPushCounter);
    } 
    else {
      // ha a gomb aktuális állapota LOW,
      // akkor a gomb ki lett kapcsolva 
      Serial.println("off"); 
    }
  }

  // az aktuális állapotot elmenti, mint utolsó állapotot
  // a loop következő lefutásához
  lastButtonState = buttonState;

  // minden negyedik gombnyomásra bekapcsolja a LED-et úgy,
  // hogy leellenőrzi a gombnyomás számlálót.
  // a moduló függvény a két szám hányadosának 
  // eredményét nézi
  if (buttonPushCounter % 4 == 0) {
    digitalWrite(ledPin, HIGH);
  } 
  else {
    digitalWrite(ledPin, LOW);
  }  
}


